package app

import (
	"net/http"

	"git.pbiernat.dev/egommerce/identity-service/internal/app/handler"
	"github.com/gorilla/mux"
)

func SetupRouter(env *handler.Env) *mux.Router {
	r := mux.NewRouter()
	r.NotFoundHandler = &handler.NotFoundHandler{}
	r.MethodNotAllowedHandler = &handler.MethodNotAllowedHandler{}

	r.Use(PrepareHeadersMiddleware)
	r.Use(ValidateJsonBodyMiddleware) // probably not needed
	r.Use(LoggingMiddleware)

	r.Handle("/health", handler.Init(env, handler.HealthCheckHandler)).Methods(http.MethodGet)
	r.Handle("/login", handler.Init(env, handler.AuthLoginHandler)).Methods(http.MethodPost)

	return r
}
